require "rhymetyme/version"
require 'rubygems'
require 'HTTParty'



class String
	def to_rhyme
		RhymeTyme.new(self)
	end
end

class RhymeTyme
	include HTTParty

	base_uri "http://rhymebrain.com/talk?"

	attr_accessor :word, :response, :wordinfo

	def initialize(word, response=[], wordinfo={})
		self.word = word
		self.response = self.class.get("function=getRhymes&word=#{word}")
		self.wordinfo = self.class.get("function=getWordInfo&word=#{word}")
	end

	def random_rhyme
		random = response[rand(response.length)]
		while !(random["score"] >= 300)
			random = response[rand(response.length)]
		end
		return random["word"]
	end

	def all_rhymes
		rhymes = []
		response.each do |obj|
			rhymes << obj["word"] if obj["score"] >= 300
		end
		return rhymes
	end

	def self.find_rhymes(word, syllables=nil)
		response = self.get("function=getRhymes&word=#{word}")
		rhymes = []
		syllable_match = []
		if response.success?
			response.each do |obj|
				if (obj["score"] >= 300)
					rhymes << obj["word"]
				end
				if syllables
					syllable_match << obj["word"] if obj["syllables"] == syllables.to_s
				else
					syllable_match << obj["word"]
				end
			end
			return rhymes & syllable_match
		else
			response.response
		end
	end

	def rhymes_with?(word)
		all_rhymes = self.class.find_rhymes(self.word)
		all_rhymes.include?(word)
	end

	def is_swear?
		wordinfo["flags"].include?("a")
	end

	def syllable_count
		wordinfo["syllables"]
	end


end

